#include<bits/stdc++.h>
using namespace std;
long long br[10000000];
int main()
{
    long long n;
    cin>>n;
    long long a,b;
    long long mina=9999999999,maxb=0;
    for(long long i=0; i<n; i++)
    {
        cin>>a>>b;
        mina=min(mina,a);
        maxb=max(maxb,b);
        for(long long j=a; j<b; j++)
        {
            br[j]++;
        }
    }
    long long maxbr=0;
    for(long long i=mina; i<=maxb; i++)
    {
        maxbr=max(br[i],maxbr);
    }
    long long ans=0;
    for(long long i=mina; i<=maxb; i++)
    {
        if(br[i]==maxbr)
        {
            ans++;
        }
    }
    cout<<maxbr<<endl;
    cout<<ans;
    return 0;
}
